# Vending Machine

This was taken from Guy Royse's github at https://github.com/guyroyse/vending-machine-kata


In this exercise you will build the brains of a vending machine.  It will accept money, make change, maintain
inventory, and dispense products.  All the things that you might expect a vending machine to accomplish.

There are two options for today.  You can implement the change making part of the vending machine several times 
using different constraints/variation or try to implement the entire machine.

# constraints/variations

FROM: https://www.coderetreat.org/pages/facilitating/activity-catalog/

- No naked primitives: They must be enclosed in a class
- No conditional statements: No ifs, no switch, no loops for conditional.
    - The alternatives are polymorphism and hashtables
    - Conditional statements are a form of primitive obsession 
    (we tend to use the lowest level of abstraction instead of choosing a higher level). 
    For example, we may choose an int for an employee number instead of an employee number class.
- Every method must be void: Very challenging; it encourages “tell don’t ask” style. 
In game of life, you might have a GetNextGenaration method. 
Instead you might write CreateNextGeneration.
- No loops

- Only four lines per method
- Only immutable objects


# Features

## Accept Coins
  
_As a vendor_  
_I want a vending machine that accepts coins_  
_So that I can collect money from the customer_  

The vending machine will accept valid coins (nickels, dimes, and quarters) and reject invalid ones (pennies).  When a
valid coin is inserted the amount of the coin will be added to the current amount and the display will be updated.
When there are no coins inserted, the machine displays INSERT COIN.  **Rejected coins are placed in the coin return.**

NOTE: The temptation here will be to create Coin objects that know their value.  However, this is not how a real
  vending machine works.  Instead, it identifies coins by their weight and size and then assigns a value to what
  was inserted.  You will need to do something similar.  This can be simulated using strings, constants, enums,
  symbols, or something of that nature.
  
### VALID COIN STATISTICS

|   |Nickel| Dime| Quarter |
|---|---|---|---|
|*weight*|5.000 g|2.268 g|5.670 g|
|*diameter*|21.21 mm|17.91 mm|24.26 mm|


# More requirements (If you want to try variations, this might be a good place to stop)

## Select Product

_As a vendor_  
_I want customers to select products_  
_So that I can give them an incentive to put money in the machine_  

There are three products: cola for $1.00, chips for $0.50, and candy for $0.65.  When the respective button is pressed
and enough money has been inserted, the product is dispensed and the machine displays THANK YOU.  If the display is
checked again, it will display INSERT COIN and the current amount will be set to $0.00.  If there is not enough money
inserted then the machine displays PRICE and the price of the item and subsequent checks of the display will display
either INSERT COIN or the current amount as appropriate.

## Make Change

_As a vendor_  
_I want customers to receive correct change_  
_So that they will use the vending machine again_  

When a product is selected that costs less than the amount of money in the machine, then the remaining amount is placed
in the coin return.

## Return Coins

_As a customer_  
_I want to have my money returned_  
_So that I can change my mind about buying stuff from the vending machine_  

When the return coins button is pressed, the money the customer has placed in the machine is returned and the display shows
INSERT COIN.

## Sold Out

_As a customer_  
_I want to be told when the item I have selected is not available_  
_So that I can select another item_  

When the item selected by the customer is out of stock, the machine displays SOLD OUT.  If the display is checked again,
it will display the amount of money remaining in the machine or INSERT COIN if there is no money in the machine.

## Exact Change Only

_As a customer_  
_I want to be told when exact change is required_  
_So that I can determine if I can buy something with the money I have before inserting it_  

When the machine is not able to make change with the money in the machine for any of the items that it sells, it will
display EXACT CHANGE ONLY instead of INSERT COIN.
